// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * Phase to phase related measured values of a three-phase system (DEL)
 * </pre>
 *
 * Protobuf type {@code commonmodule.DEL}
 */
public final class DEL extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.DEL)
    DELOrBuilder {
private static final long serialVersionUID = 0L;
  // Use DEL.newBuilder() to construct.
  private DEL(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private DEL() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new DEL();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_DEL_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_DEL_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.DEL.class, openfmb.commonmodule.DEL.Builder.class);
  }

  public static final int PHSAB_FIELD_NUMBER = 1;
  private openfmb.commonmodule.CMV phsAB_;
  /**
   * <pre>
   * Value of phase A to phase B measurement.
   * </pre>
   *
   * <code>.commonmodule.CMV phsAB = 1;</code>
   * @return Whether the phsAB field is set.
   */
  @java.lang.Override
  public boolean hasPhsAB() {
    return phsAB_ != null;
  }
  /**
   * <pre>
   * Value of phase A to phase B measurement.
   * </pre>
   *
   * <code>.commonmodule.CMV phsAB = 1;</code>
   * @return The phsAB.
   */
  @java.lang.Override
  public openfmb.commonmodule.CMV getPhsAB() {
    return phsAB_ == null ? openfmb.commonmodule.CMV.getDefaultInstance() : phsAB_;
  }
  /**
   * <pre>
   * Value of phase A to phase B measurement.
   * </pre>
   *
   * <code>.commonmodule.CMV phsAB = 1;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.CMVOrBuilder getPhsABOrBuilder() {
    return phsAB_ == null ? openfmb.commonmodule.CMV.getDefaultInstance() : phsAB_;
  }

  public static final int PHSBC_FIELD_NUMBER = 2;
  private openfmb.commonmodule.CMV phsBC_;
  /**
   * <pre>
   * Value of phase B to phase C measurement.
   * </pre>
   *
   * <code>.commonmodule.CMV phsBC = 2;</code>
   * @return Whether the phsBC field is set.
   */
  @java.lang.Override
  public boolean hasPhsBC() {
    return phsBC_ != null;
  }
  /**
   * <pre>
   * Value of phase B to phase C measurement.
   * </pre>
   *
   * <code>.commonmodule.CMV phsBC = 2;</code>
   * @return The phsBC.
   */
  @java.lang.Override
  public openfmb.commonmodule.CMV getPhsBC() {
    return phsBC_ == null ? openfmb.commonmodule.CMV.getDefaultInstance() : phsBC_;
  }
  /**
   * <pre>
   * Value of phase B to phase C measurement.
   * </pre>
   *
   * <code>.commonmodule.CMV phsBC = 2;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.CMVOrBuilder getPhsBCOrBuilder() {
    return phsBC_ == null ? openfmb.commonmodule.CMV.getDefaultInstance() : phsBC_;
  }

  public static final int PHSCA_FIELD_NUMBER = 3;
  private openfmb.commonmodule.CMV phsCA_;
  /**
   * <pre>
   * Value of phase C to phase A measurement.
   * </pre>
   *
   * <code>.commonmodule.CMV phsCA = 3;</code>
   * @return Whether the phsCA field is set.
   */
  @java.lang.Override
  public boolean hasPhsCA() {
    return phsCA_ != null;
  }
  /**
   * <pre>
   * Value of phase C to phase A measurement.
   * </pre>
   *
   * <code>.commonmodule.CMV phsCA = 3;</code>
   * @return The phsCA.
   */
  @java.lang.Override
  public openfmb.commonmodule.CMV getPhsCA() {
    return phsCA_ == null ? openfmb.commonmodule.CMV.getDefaultInstance() : phsCA_;
  }
  /**
   * <pre>
   * Value of phase C to phase A measurement.
   * </pre>
   *
   * <code>.commonmodule.CMV phsCA = 3;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.CMVOrBuilder getPhsCAOrBuilder() {
    return phsCA_ == null ? openfmb.commonmodule.CMV.getDefaultInstance() : phsCA_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (phsAB_ != null) {
      output.writeMessage(1, getPhsAB());
    }
    if (phsBC_ != null) {
      output.writeMessage(2, getPhsBC());
    }
    if (phsCA_ != null) {
      output.writeMessage(3, getPhsCA());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (phsAB_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getPhsAB());
    }
    if (phsBC_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getPhsBC());
    }
    if (phsCA_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getPhsCA());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.DEL)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.DEL other = (openfmb.commonmodule.DEL) obj;

    if (hasPhsAB() != other.hasPhsAB()) return false;
    if (hasPhsAB()) {
      if (!getPhsAB()
          .equals(other.getPhsAB())) return false;
    }
    if (hasPhsBC() != other.hasPhsBC()) return false;
    if (hasPhsBC()) {
      if (!getPhsBC()
          .equals(other.getPhsBC())) return false;
    }
    if (hasPhsCA() != other.hasPhsCA()) return false;
    if (hasPhsCA()) {
      if (!getPhsCA()
          .equals(other.getPhsCA())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasPhsAB()) {
      hash = (37 * hash) + PHSAB_FIELD_NUMBER;
      hash = (53 * hash) + getPhsAB().hashCode();
    }
    if (hasPhsBC()) {
      hash = (37 * hash) + PHSBC_FIELD_NUMBER;
      hash = (53 * hash) + getPhsBC().hashCode();
    }
    if (hasPhsCA()) {
      hash = (37 * hash) + PHSCA_FIELD_NUMBER;
      hash = (53 * hash) + getPhsCA().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.DEL parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.DEL parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.DEL parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.DEL parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.DEL parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.DEL parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.DEL parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.DEL parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.DEL parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.DEL parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.DEL parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.DEL parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.DEL prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Phase to phase related measured values of a three-phase system (DEL)
   * </pre>
   *
   * Protobuf type {@code commonmodule.DEL}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.DEL)
      openfmb.commonmodule.DELOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_DEL_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_DEL_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.DEL.class, openfmb.commonmodule.DEL.Builder.class);
    }

    // Construct using openfmb.commonmodule.DEL.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      phsAB_ = null;
      if (phsABBuilder_ != null) {
        phsABBuilder_.dispose();
        phsABBuilder_ = null;
      }
      phsBC_ = null;
      if (phsBCBuilder_ != null) {
        phsBCBuilder_.dispose();
        phsBCBuilder_ = null;
      }
      phsCA_ = null;
      if (phsCABuilder_ != null) {
        phsCABuilder_.dispose();
        phsCABuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_DEL_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.DEL getDefaultInstanceForType() {
      return openfmb.commonmodule.DEL.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.DEL build() {
      openfmb.commonmodule.DEL result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.DEL buildPartial() {
      openfmb.commonmodule.DEL result = new openfmb.commonmodule.DEL(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.commonmodule.DEL result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.phsAB_ = phsABBuilder_ == null
            ? phsAB_
            : phsABBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.phsBC_ = phsBCBuilder_ == null
            ? phsBC_
            : phsBCBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.phsCA_ = phsCABuilder_ == null
            ? phsCA_
            : phsCABuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.DEL) {
        return mergeFrom((openfmb.commonmodule.DEL)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.DEL other) {
      if (other == openfmb.commonmodule.DEL.getDefaultInstance()) return this;
      if (other.hasPhsAB()) {
        mergePhsAB(other.getPhsAB());
      }
      if (other.hasPhsBC()) {
        mergePhsBC(other.getPhsBC());
      }
      if (other.hasPhsCA()) {
        mergePhsCA(other.getPhsCA());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getPhsABFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getPhsBCFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getPhsCAFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.CMV phsAB_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.CMV, openfmb.commonmodule.CMV.Builder, openfmb.commonmodule.CMVOrBuilder> phsABBuilder_;
    /**
     * <pre>
     * Value of phase A to phase B measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsAB = 1;</code>
     * @return Whether the phsAB field is set.
     */
    public boolean hasPhsAB() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * Value of phase A to phase B measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsAB = 1;</code>
     * @return The phsAB.
     */
    public openfmb.commonmodule.CMV getPhsAB() {
      if (phsABBuilder_ == null) {
        return phsAB_ == null ? openfmb.commonmodule.CMV.getDefaultInstance() : phsAB_;
      } else {
        return phsABBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Value of phase A to phase B measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsAB = 1;</code>
     */
    public Builder setPhsAB(openfmb.commonmodule.CMV value) {
      if (phsABBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        phsAB_ = value;
      } else {
        phsABBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value of phase A to phase B measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsAB = 1;</code>
     */
    public Builder setPhsAB(
        openfmb.commonmodule.CMV.Builder builderForValue) {
      if (phsABBuilder_ == null) {
        phsAB_ = builderForValue.build();
      } else {
        phsABBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value of phase A to phase B measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsAB = 1;</code>
     */
    public Builder mergePhsAB(openfmb.commonmodule.CMV value) {
      if (phsABBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          phsAB_ != null &&
          phsAB_ != openfmb.commonmodule.CMV.getDefaultInstance()) {
          getPhsABBuilder().mergeFrom(value);
        } else {
          phsAB_ = value;
        }
      } else {
        phsABBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value of phase A to phase B measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsAB = 1;</code>
     */
    public Builder clearPhsAB() {
      bitField0_ = (bitField0_ & ~0x00000001);
      phsAB_ = null;
      if (phsABBuilder_ != null) {
        phsABBuilder_.dispose();
        phsABBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value of phase A to phase B measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsAB = 1;</code>
     */
    public openfmb.commonmodule.CMV.Builder getPhsABBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getPhsABFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Value of phase A to phase B measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsAB = 1;</code>
     */
    public openfmb.commonmodule.CMVOrBuilder getPhsABOrBuilder() {
      if (phsABBuilder_ != null) {
        return phsABBuilder_.getMessageOrBuilder();
      } else {
        return phsAB_ == null ?
            openfmb.commonmodule.CMV.getDefaultInstance() : phsAB_;
      }
    }
    /**
     * <pre>
     * Value of phase A to phase B measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsAB = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.CMV, openfmb.commonmodule.CMV.Builder, openfmb.commonmodule.CMVOrBuilder> 
        getPhsABFieldBuilder() {
      if (phsABBuilder_ == null) {
        phsABBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.CMV, openfmb.commonmodule.CMV.Builder, openfmb.commonmodule.CMVOrBuilder>(
                getPhsAB(),
                getParentForChildren(),
                isClean());
        phsAB_ = null;
      }
      return phsABBuilder_;
    }

    private openfmb.commonmodule.CMV phsBC_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.CMV, openfmb.commonmodule.CMV.Builder, openfmb.commonmodule.CMVOrBuilder> phsBCBuilder_;
    /**
     * <pre>
     * Value of phase B to phase C measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsBC = 2;</code>
     * @return Whether the phsBC field is set.
     */
    public boolean hasPhsBC() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * Value of phase B to phase C measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsBC = 2;</code>
     * @return The phsBC.
     */
    public openfmb.commonmodule.CMV getPhsBC() {
      if (phsBCBuilder_ == null) {
        return phsBC_ == null ? openfmb.commonmodule.CMV.getDefaultInstance() : phsBC_;
      } else {
        return phsBCBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Value of phase B to phase C measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsBC = 2;</code>
     */
    public Builder setPhsBC(openfmb.commonmodule.CMV value) {
      if (phsBCBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        phsBC_ = value;
      } else {
        phsBCBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value of phase B to phase C measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsBC = 2;</code>
     */
    public Builder setPhsBC(
        openfmb.commonmodule.CMV.Builder builderForValue) {
      if (phsBCBuilder_ == null) {
        phsBC_ = builderForValue.build();
      } else {
        phsBCBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value of phase B to phase C measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsBC = 2;</code>
     */
    public Builder mergePhsBC(openfmb.commonmodule.CMV value) {
      if (phsBCBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          phsBC_ != null &&
          phsBC_ != openfmb.commonmodule.CMV.getDefaultInstance()) {
          getPhsBCBuilder().mergeFrom(value);
        } else {
          phsBC_ = value;
        }
      } else {
        phsBCBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value of phase B to phase C measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsBC = 2;</code>
     */
    public Builder clearPhsBC() {
      bitField0_ = (bitField0_ & ~0x00000002);
      phsBC_ = null;
      if (phsBCBuilder_ != null) {
        phsBCBuilder_.dispose();
        phsBCBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value of phase B to phase C measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsBC = 2;</code>
     */
    public openfmb.commonmodule.CMV.Builder getPhsBCBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getPhsBCFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Value of phase B to phase C measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsBC = 2;</code>
     */
    public openfmb.commonmodule.CMVOrBuilder getPhsBCOrBuilder() {
      if (phsBCBuilder_ != null) {
        return phsBCBuilder_.getMessageOrBuilder();
      } else {
        return phsBC_ == null ?
            openfmb.commonmodule.CMV.getDefaultInstance() : phsBC_;
      }
    }
    /**
     * <pre>
     * Value of phase B to phase C measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsBC = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.CMV, openfmb.commonmodule.CMV.Builder, openfmb.commonmodule.CMVOrBuilder> 
        getPhsBCFieldBuilder() {
      if (phsBCBuilder_ == null) {
        phsBCBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.CMV, openfmb.commonmodule.CMV.Builder, openfmb.commonmodule.CMVOrBuilder>(
                getPhsBC(),
                getParentForChildren(),
                isClean());
        phsBC_ = null;
      }
      return phsBCBuilder_;
    }

    private openfmb.commonmodule.CMV phsCA_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.CMV, openfmb.commonmodule.CMV.Builder, openfmb.commonmodule.CMVOrBuilder> phsCABuilder_;
    /**
     * <pre>
     * Value of phase C to phase A measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsCA = 3;</code>
     * @return Whether the phsCA field is set.
     */
    public boolean hasPhsCA() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * Value of phase C to phase A measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsCA = 3;</code>
     * @return The phsCA.
     */
    public openfmb.commonmodule.CMV getPhsCA() {
      if (phsCABuilder_ == null) {
        return phsCA_ == null ? openfmb.commonmodule.CMV.getDefaultInstance() : phsCA_;
      } else {
        return phsCABuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Value of phase C to phase A measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsCA = 3;</code>
     */
    public Builder setPhsCA(openfmb.commonmodule.CMV value) {
      if (phsCABuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        phsCA_ = value;
      } else {
        phsCABuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value of phase C to phase A measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsCA = 3;</code>
     */
    public Builder setPhsCA(
        openfmb.commonmodule.CMV.Builder builderForValue) {
      if (phsCABuilder_ == null) {
        phsCA_ = builderForValue.build();
      } else {
        phsCABuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value of phase C to phase A measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsCA = 3;</code>
     */
    public Builder mergePhsCA(openfmb.commonmodule.CMV value) {
      if (phsCABuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          phsCA_ != null &&
          phsCA_ != openfmb.commonmodule.CMV.getDefaultInstance()) {
          getPhsCABuilder().mergeFrom(value);
        } else {
          phsCA_ = value;
        }
      } else {
        phsCABuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value of phase C to phase A measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsCA = 3;</code>
     */
    public Builder clearPhsCA() {
      bitField0_ = (bitField0_ & ~0x00000004);
      phsCA_ = null;
      if (phsCABuilder_ != null) {
        phsCABuilder_.dispose();
        phsCABuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value of phase C to phase A measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsCA = 3;</code>
     */
    public openfmb.commonmodule.CMV.Builder getPhsCABuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getPhsCAFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Value of phase C to phase A measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsCA = 3;</code>
     */
    public openfmb.commonmodule.CMVOrBuilder getPhsCAOrBuilder() {
      if (phsCABuilder_ != null) {
        return phsCABuilder_.getMessageOrBuilder();
      } else {
        return phsCA_ == null ?
            openfmb.commonmodule.CMV.getDefaultInstance() : phsCA_;
      }
    }
    /**
     * <pre>
     * Value of phase C to phase A measurement.
     * </pre>
     *
     * <code>.commonmodule.CMV phsCA = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.CMV, openfmb.commonmodule.CMV.Builder, openfmb.commonmodule.CMVOrBuilder> 
        getPhsCAFieldBuilder() {
      if (phsCABuilder_ == null) {
        phsCABuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.CMV, openfmb.commonmodule.CMV.Builder, openfmb.commonmodule.CMVOrBuilder>(
                getPhsCA(),
                getParentForChildren(),
                isClean());
        phsCA_ = null;
      }
      return phsCABuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.DEL)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.DEL)
  private static final openfmb.commonmodule.DEL DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.DEL();
  }

  public static openfmb.commonmodule.DEL getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<DEL>
      PARSER = new com.google.protobuf.AbstractParser<DEL>() {
    @java.lang.Override
    public DEL parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<DEL> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<DEL> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.DEL getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

